 global Paramdraw Omegadraw H0draw STATE1 STATE2 covdata ydata xdata
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
% START LOOP FOR SAMPLING FROM THE UNOBSERVED STATE %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
 
   params=Paramdraw(k-1,:);
   warning off;       
              
    % start going in the reverse way;
    % Monte Carlo Smoother in Geweke and Tanizaki.
   
      sig2 = 0.01;
 
      xcand=[normrnd(STATE1(T,k-1),sqrt(sig2)) normrnd(STATE2(T,k-1),sqrt(sig2))];
      numx1=log(normpdf(xcand(1),H0(1),sqrt(Sigma(1,1))))+log(normpdf(xcand(2),H0(2),sqrt(Sigma(2,2))))+...
           log(normpdf(ydata(T,1),measfun1(params,covdata(T,:),xcand),sqrt(Omegadraw(k-1,1))))+...
           log(normpdf(ydata(T,2),measfun2(params,covdata(T,:),xcand),sqrt(Omegadraw(k-1,2))))+...
           log(normpdf(ydata(T,3),measfun3(params,covdata(T,:),xcand),sqrt(Omegadraw(k-1,3))));
      numx1=numx1;
  
      
      denx1=log(normpdf(STATE1(T,k-1),H0(1),sqrt(Sigma(1,1))))+...
           log(normpdf(STATE2(T,k-1),H0(2),sqrt(Sigma(2,2))))+...
           log(normpdf(ydata(T,1),measfun1(params,covdata(T,:),[STATE1(T,k-1) STATE2(T,k-1)]),sqrt(Omegadraw(k-1,1))))+...
           log(normpdf(ydata(T,2),measfun2(params,covdata(T,:),[STATE1(T,k-1) STATE2(T,k-1)]),sqrt(Omegadraw(k-1,2))))+...
           log(normpdf(ydata(T,3),measfun3(params,covdata(T,:),[STATE1(T,k-1) STATE2(T,k-1)]),sqrt(Omegadraw(k-1,3))));
       
      denx1=denx1;
   
     
     u=unifrnd(0,1);
     if  (denx1==-Inf)&(numx1==-Inf);
                STATE1(T,k)=STATE1(T,k-1);
                STATE2(T,k)=STATE2(T,k-1);
     elseif denx1==-Inf;
                STATE1(T,k)=xcand(1);
                STATE2(T,k)=xcand(2);
     else
           if    u<=(exp(numx1)/exp(denx1));
                STATE1(T,k)=xcand(1);
                STATE2(T,k)=xcand(2);
 
            else
                STATE1(T,k)=STATE1(T,k-1);
                STATE2(T,k)=STATE2(T,k-1);
            end
        end
        
%           
   nrev=T-1;
   while nrev>1;
   
   xcand=[normrnd(STATE1(nrev,k-1),sqrt(sig2)) normrnd(STATE2(nrev,k-1),sqrt(sig2))];
      numx2=log(normpdf(xcand(1),H0(1),sqrt(Sigma(1,1))))+log(normpdf(xcand(2),H0(2),sqrt(Sigma(2,2))))+...
           log(normpdf(ydata(nrev,1),measfun1(params,covdata(nrev,:),xcand),sqrt(Omegadraw(k-1,1))))+...
           log(normpdf(ydata(nrev,2),measfun2(params,covdata(nrev,:),xcand),sqrt(Omegadraw(k-1,2))))+...
           log(normpdf(ydata(nrev,3),measfun3(params,covdata(nrev,:),xcand),sqrt(Omegadraw(k-1,3))))+...
           log(normpdf(STATE1(nrev+1,k-1),H0(1),sqrt(Sigma(1,1))))+log(normpdf(STATE2(nrev+1,k-1),H0(2),sqrt(Sigma(2,2))));
       numx2=numx2;
    
       
      denx2=log(normpdf(STATE1(nrev,k-1),H0(1),sqrt(Sigma(1,1))))+log(normpdf(STATE2(nrev,k-1),H0(2),sqrt(Sigma(2,2))))+...
           log(normpdf(ydata(nrev,1),measfun1(params,covdata(nrev,:),[STATE1(nrev,k-1) STATE2(nrev,k-1)]),sqrt(Omegadraw(k-1,1))))+...
           log(normpdf(ydata(nrev,2),measfun2(params,covdata(nrev,:),[STATE1(nrev,k-1) STATE2(nrev,k-1)]),sqrt(Omegadraw(k-1,2))))+...
           log(normpdf(ydata(nrev,3),measfun3(params,covdata(nrev,:),[STATE1(nrev,k-1) STATE2(nrev,k-1)]),sqrt(Omegadraw(k-1,3))))+...
           log(normpdf(STATE1(nrev+1,k-1),H0(1),sqrt(Sigma(1,1))))+log(normpdf(STATE2(nrev+1,k-1),H0(2) ,sqrt(Sigma(2,2))));
      denx2=denx2;
    
      
       u=unifrnd(0,1);
       if  (denx2==-Inf)&(numx2==-Inf);
                STATE1(nrev,k)=STATE1(nrev,k-1);
                STATE2(nrev,k)=STATE2(nrev,k-1);
            elseif denx2==-Inf;
          STATE1(nrev,k)=xcand(1);
          STATE2(nrev,k)=xcand(2);
      else
           if    u<=(exp(numx2)/exp(denx2));
                STATE1(nrev,k)=xcand(1);
                STATE2(nrev,k)=xcand(2);
        
            else
                STATE1(nrev,k)=STATE1(nrev,k-1);
                STATE2(nrev,k)=STATE2(nrev,k-1);
            end
        end
     nrev=nrev-1;
    end
    
     xcand=[normrnd(STATE1(1,k-1),sqrt(sig2)) normrnd(STATE2(1,k-1),sqrt(sig2))];
      
      numx3=log(normpdf(xcand(1),H0(1),sqrt(Sigma(1,1))))+log(normpdf(xcand(2),H0(2),sqrt(Sigma(2,2))))+...
           log(normpdf(ydata(1,1),measfun1(params,covdata(1,:),xcand),sqrt(Omegadraw(k-1,1))))+...
           log(normpdf(ydata(1,2),measfun2(params,covdata(1,:),xcand),sqrt(Omegadraw(k-1,2))))+...
           log(normpdf(ydata(1,3),measfun3(params,covdata(1,:),xcand),sqrt(Omegadraw(k-1,3))))+...
           log(normpdf(STATE1(2,k-1),H0(1),sqrt(Sigma(1,1))))+log(normpdf(STATE2(2,k-1),H0(2),sqrt(Sigma(2,2))));
       
       numx3=numx3;
 
       
      denx3=log(normpdf(STATE1(1,k-1),H0(1),sqrt(Sigma(1,1))))+log(normpdf(STATE2(1,k-1),H0(2),sqrt(Sigma(2,2))))+...
           log(normpdf(ydata(1,1),measfun1(params,covdata(1,:),[STATE1(1,k-1) STATE2(1,k-1)]),sqrt(Omegadraw(k-1,1))))+...
           log(normpdf(ydata(1,2),measfun2(params,covdata(1,:),[STATE1(1,k-1) STATE2(1,k-1)]),sqrt(Omegadraw(k-1,2))))+...
           log(normpdf(ydata(1,3),measfun3(params,covdata(1,:),[STATE1(1,k-1) STATE2(1,k-1)]),sqrt(Omegadraw(k-1,3))))+...
            log(normpdf(STATE1(2,k-1),H0(1),sqrt(Sigma(1,1))))+log(normpdf(STATE2(2,k-1),H0(2),sqrt(Sigma(2,2))));
         denx3=denx3;
  
 
      u=unifrnd(0,1);
      if  (denx3==-Inf)&(numx3==-Inf);
                STATE1(1,k)=STATE1(1,k-1);
                STATE2(1,k)=STATE2(1,k-1);
            elseif denx3==0;
          STATE1(1,k)=xcand(1);
          STATE2(1,k)=xcand(2);
      else
           if    u<=(exp(numx3)/exp(denx3));
                STATE1(1,k)=xcand(1);
                STATE2(1,k)=xcand(2);
               
            else
                STATE1(1,k)=STATE1(1,k-1);
                STATE2(1,k)=STATE2(1,k-1);
            end
        end
           
xdata=[STATE1(:,k) STATE2(:,k)]; 
