function y=measfun(param,covdata,data);

% data is a T x 2 matrix

y=zeros(rows(data),3);

sigma=param(1);
rho=param(2);
mu=param(3);
lambda=param(4);
alpha=param(5);
deltas=param(9);
deltae=param(10);
xi = param(11);
nu = param(12);


kwiggle = (xi.*covdata(:,1).^nu+(1-xi).*covdata(:,6).^nu).^(1.0/nu);

y(:,1)=(1-alpha)*((mu.*(covdata(:,3).^sigma).*exp(data(:,1).*sigma)+(1-mu).*(lambda.*kwiggle.^rho+...
    (1-lambda).*covdata(:,4).^rho.*(exp(data(:,2)*rho))).^(sigma/rho)).^(-1)).*...
    ((mu.*covdata(:,3).^(sigma).*exp(data(:,1)*sigma))+(1-mu).*(lambda.*kwiggle.^rho+(1-lambda).*covdata(:,4).^rho.*exp(data(:,2).*rho)).^(sigma/rho-1)...
    .*(1-lambda).*covdata(:,4).^rho.*exp(data(:,2).*(rho)));


 Numy=(1-mu).*(lambda.*kwiggle.^rho+(1-lambda).*covdata(:,4).^rho.*exp(data(:,2)*rho)).^(sigma/rho-1).*...
    (1-lambda).*covdata(:,4).^rho.*exp(data(:,2)*(rho)).*covdata(:,3);
   Deny=mu.*covdata(:,3).^sigma.*exp(data(:,1)*(sigma)).*covdata(:,4);

y(:,2)=Numy./Deny;

GKS=alpha.*covdata(:,2).^(alpha-1).*(mu*covdata(:,3).^sigma.*exp(sigma*data(:,1))+(1-mu)*(lambda.*kwiggle.^(rho)+(1-lambda).*covdata(:,4).^rho.*...
    exp(data(:,2)*rho)).^(sigma/rho)).^((1-alpha)/sigma);

GKE=(1-alpha).*covdata(:,2).^alpha.*(mu*covdata(:,3).^sigma.*exp(sigma*data(:,1))+(1-mu)*(lambda.*kwiggle.^(rho)+(1-lambda).*covdata(:,4).^rho.*...
    exp(data(:,2)*rho)).^(sigma/rho)).^((1-alpha)/sigma-1).*(1-mu).*(lambda.*kwiggle.^rho+(1-lambda).*covdata(:,4).^rho.*...
    exp(data(:,2)*rho)).^(sigma/rho-1).*lambda.*kwiggle.^(rho-1).*(1.0/nu).*(xi.*covdata(:,1).^nu+(1-xi).*covdata(:,6).^nu).^(1.0/nu-1)*xi*nu.*covdata(:,1).^(nu-1);



y(:,3)=-GKE./(covdata(:,5).*(1-deltae))+((1-deltas)/(1-deltae)+GKS./(1-deltae));

