
 global Paramdraw Omegadraw H0draw STATE1 STATE2 covdata ydata xdata

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % Measurement equations            %
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
paramcand=[trnorm(Paramdraw(k-1,1),sqrt(Sigmaparam(1,1)),-2,1) trnorm(Paramdraw(k-1,2),sqrt(Sigmaparam(2,2)),-2,1)... 
            trnorm(Paramdraw(k-1,3),sqrt(Sigmaparam(3,3)),0,1) trnorm(Paramdraw(k-1,4),sqrt(Sigmaparam(4,4)),0,1)... 
            trnorm(Paramdraw(k-1,5),sqrt(Sigmaparam(5,5)),0,1) Paramdraw(k-1,6) Paramdraw(k-1,7) ...
            Paramdraw(k-1,8:10) trnorm(Paramdraw(k-1,11),sqrt(Sigmaparam(6,6)),0,1) Paramdraw(k-1,12)];
 
 
 exponent=sum((((ydata-measfun(paramcand,covdata,xdata))*inv(diag(Omegadraw(k-1,:)))).*(ydata-measfun(paramcand,covdata,xdata)))')';
 qnp=-(cols(ydata)/2)*log(2*pi)-0.5*log(det(diag(Omegadraw(k-1,:))))-(1/2)*exponent;
likn=sum(qnp);

nump=likn+log(normpdf(paramcand(1),m_sigma,s_sigma))+...
     log(normpdf(paramcand(5),m_alpha,s_alpha))+log(normpdf(paramcand(2),m_rho,s_rho))...
      +log(normpdf(paramcand(3),m_mu,s_mu))+log(normpdf(paramcand(4),m_lambda,s_lambda))+log(normpdf(paramcand(11),m_xi,s_xi));

 exponent=sum((((ydata-measfun(Paramdraw(k-1,:),covdata,xdata))*inv(diag(Omegadraw(k-1,:)))).*(ydata-measfun(Paramdraw(k-1,:),covdata,xdata)))')';
 qdp=-(cols(ydata)/2)*log(2*pi)-0.5*log(det(diag(Omegadraw(k-1,:))))-(1/2)*exponent;
 likd=sum(qdp);
 denp=likd+log(normpdf(Paramdraw(k-1,1),m_sigma,s_sigma))+log(normpdf(Paramdraw(k-1,5),m_alpha,s_alpha))+...
           log(normpdf(Paramdraw(k-1,2),m_rho,s_rho))+log(normpdf(Paramdraw(k-1,3),m_mu,s_mu))...
           +log(normpdf(Paramdraw(k-1,4),m_lambda,s_lambda))+log(normpdf(Paramdraw(k-1,11),m_xi,s_xi));

if (nump-denp==0.0)
    diff = -Inf;
elseif (nump==-Inf) 
    diff = -Inf;
    
elseif (nump>-Inf)&(denp==-Inf)
    diff = nump-denp;
else
    diff = nump-denp;
    
end

ac_prob = min(1,exp(diff));

 
        
     
     u=unifrnd(0,1);
     if u<=(ac_prob);
         Paramdraw(k,:)=paramcand;
   
      else
           Paramdraw(k,:)=Paramdraw(k-1,:);
     end
 
 

Omegacand=diag([trnorm(Omegadraw(k-1,1),sqrt(Sigmaomega(1,1)),0,15) trnorm(Omegadraw(k-1,2),sqrt(Sigmaomega(1,1)),0,15)...
        trnorm(Omegadraw(k-1,3),sqrt(Sigmaomega(1,1)),0,15)]);


 exponent=sum((((ydata-measfun(Paramdraw(k-1,:),covdata,xdata))*inv(Omegacand)).*(ydata-measfun(Paramdraw(k-1,:),covdata,xdata)))')';
 qnp=-(cols(ydata)/2)*log(2*pi)-0.5*log(det(Omegacand))-(1/2)*exponent;
likn=sum(qnp);
numps=likn+log(gampdf(Omegacand(1,1),a_omega,b_omega))+log(gampdf(Omegacand(2,2),a_omega,b_omega))...
     +log(gampdf(Omegacand(3,3),a_omega,b_omega));
  
  
 exponent=sum((((ydata-measfun(Paramdraw(k-1,:),covdata,xdata))*inv(diag(Omegadraw(k-1,:)))).*(ydata-measfun(Paramdraw(k-1,:),covdata,xdata)))')';
 qdp=-(cols(ydata)/2)*log(2*pi)-0.5*log(det(diag(Omegadraw(k-1,:))))-(1/2)*exponent;
 likd=sum(qdp);
 denps=likd+log(gampdf(Omegadraw(k-1,1),a_omega,b_omega))+log(gampdf(Omegadraw(k-1,2),a_omega,b_omega))...
      +log(gampdf(Omegadraw(k-1,3),a_omega,b_omega));

if (numps-denps==0.0)
    diff = -200;
else
    diff = numps-denps;
end

ac_prob = min(1,exp(diff));

 
        

     u=unifrnd(0,1);
     if u<=ac_prob;
 
         Omegadraw(k,:)=diag(Omegacand)';
         Paramdraw(k,7)=Omegacand(3,3);
        
      else
            
        Omegadraw(k,:)=Omegadraw(k-1,:);
     end  

 