function y=measfun2(param,covdata,data);

% data is a T x 2 matrix

y=zeros(rows(data),1);

sigma=param(1);
rho=param(2);
mu=param(3);
lambda=param(4);
alpha=param(5);
xi = param(11);
nu = param(12);

% Because energy enters the production function, we change.

kwiggle = (xi*covdata(:,1).^nu+(1-xi)*covdata(:,6).^nu).^(1.0/nu);

 Numy=(1-mu).*(lambda.*kwiggle.^rho+(1-lambda).*covdata(:,4).^rho.*exp(data(:,2)*rho)).^(sigma/rho-1).*...
    (1-lambda).*covdata(:,4).^rho.*exp(data(:,2)*(rho)).*covdata(:,3);
   Deny=mu.*covdata(:,3).^sigma.*exp(data(:,1)*(sigma)).*covdata(:,4);

y(:,1)=Numy./Deny;