function y=measfun3(param,covdata,data);

% data is a T x 2 matrix

y=zeros(rows(data),1);

sigma=param(1);
rho=param(2);
mu=param(3);
lambda=param(4);
alpha=param(5);
deltas=param(9);
deltae=param(10);
xi = param(11);
nu = param(12);

% Because energy enters the production function, we change.
%covdata(:,1) = (xi*covdata(:,1).^nu+(1-xi)*covdata(:,6).^nu).^(rho/nu)

kwiggle = (xi.*covdata(:,1).^nu+(1-xi).*covdata(:,6).^nu).^(1.0/nu);

GKS=alpha.*covdata(:,2).^(alpha-1).*(mu*covdata(:,3).^sigma.*exp(sigma*data(:,1))+(1-mu)*(lambda.*kwiggle.^(rho)+(1-lambda).*covdata(:,4).^rho.*...
    exp(data(:,2)*rho)).^(sigma/rho)).^((1-alpha)/sigma);

GKE=(1-alpha).*covdata(:,2).^alpha.*(mu*covdata(:,3).^sigma.*exp(sigma*data(:,1))+(1-mu)*(lambda.*kwiggle.^(rho)+(1-lambda).*covdata(:,4).^rho.*...
    exp(data(:,2)*rho)).^(sigma/rho)).^((1-alpha)/sigma-1).*(1-mu).*(lambda.*kwiggle.^rho+(1-lambda).*covdata(:,4).^rho.*...
    exp(data(:,2)*rho)).^(sigma/rho-1).*lambda.*kwiggle.^(rho-1).*(1.0/nu).*(xi.*covdata(:,1).^nu+(1-xi).*covdata(:,6).^nu).^(1.0/nu-1)*xi*nu.*covdata(:,1).^(nu-1);



y(:,1)=-GKE./(covdata(:,5).*(1-deltae))+((1-deltas)/(1-deltae)+GKS./(1-deltae));

